Public Class TreeViewForm
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub
    Friend WithEvents TreeView1 As System.Windows.Forms.TreeView
    Private components As System.ComponentModel.IContainer

    'Required by the Windows Form Designer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents CheckBox1 As System.Windows.Forms.CheckBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.TreeView1 = New System.Windows.Forms.TreeView()
        Me.CheckBox1 = New System.Windows.Forms.CheckBox()
        Me.SuspendLayout()
        '
        'TreeView1
        '
        Me.TreeView1.ImageIndex = -1
        Me.TreeView1.LabelEdit = True
        Me.TreeView1.Location = New System.Drawing.Point(24, 24)
        Me.TreeView1.Name = "TreeView1"
        Me.TreeView1.Nodes.AddRange(New System.Windows.Forms.TreeNode() {New System.Windows.Forms.TreeNode("TreeNode", New System.Windows.Forms.TreeNode() {New System.Windows.Forms.TreeNode("First Child", New System.Windows.Forms.TreeNode() {New System.Windows.Forms.TreeNode("First Grandchild"), New System.Windows.Forms.TreeNode("Second Grandchild"), New System.Windows.Forms.TreeNode("Third Grandchild")}), New System.Windows.Forms.TreeNode("Second Child"), New System.Windows.Forms.TreeNode("Third Child")})})
        Me.TreeView1.SelectedImageIndex = -1
        Me.TreeView1.Size = New System.Drawing.Size(240, 256)
        Me.TreeView1.TabIndex = 0
        '
        'CheckBox1
        '
        Me.CheckBox1.Appearance = System.Windows.Forms.Appearance.Button
        Me.CheckBox1.CheckAlign = System.Drawing.ContentAlignment.TopLeft
        Me.CheckBox1.Location = New System.Drawing.Point(280, 24)
        Me.CheckBox1.Name = "CheckBox1"
        Me.CheckBox1.Size = New System.Drawing.Size(104, 56)
        Me.CheckBox1.TabIndex = 2
        Me.CheckBox1.Text = "Display Children Count"
        Me.CheckBox1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'TreeViewForm
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(7, 17)
        Me.ClientSize = New System.Drawing.Size(400, 293)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.CheckBox1, Me.TreeView1})
        Me.Font = New System.Drawing.Font("Microsoft Sans Serif", 11.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Name = "TreeViewForm"
        Me.Text = "TreeViewForm"
        Me.ResumeLayout(False)

    End Sub

#End Region

    ' enable/disable showing of children count

    Private Sub CheckBox1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox1.CheckedChanged
        DisplayChildrenCount(TreeView1.Nodes, CheckBox1.Checked)
    End Sub

    ' display the number of children nodes in the caption
    ' of each node

    Sub DisplayChildrenCount(ByVal nodes As TreeNodeCollection, ByVal display As Boolean)
        ' append the number of children to the node's Text
        ' (after deleting existing count, if any)

        Dim node As TreeNode
        For Each node In nodes
            ' Remove any child count at the end of the Text, if there.
            node.Text = System.Text.RegularExpressions.Regex.Replace(node.Text, " \[.*\]$", "")
            ' Add it again, if so requested.
            If display Then
                node.Text += " [" & CStr(node.Nodes.Count) & "]"
            End If
            ' Recurse over child nodes.
            DisplayChildrenCount(node.Nodes, display)
        Next
    End Sub

    ' Refuse to edit a node that has a children count on its Text.

    Private Sub TreeView1_BeforeLabelEdit(ByVal sender As Object, ByVal e As System.Windows.Forms.NodeLabelEditEventArgs) Handles TreeView1.BeforeLabelEdit
        If System.Text.RegularExpressions.Regex.IsMatch(e.Node.Text, " \[.*\]$") Then
            e.CancelEdit = True
            MessageBox.Show("You can't edit while children count is displayed")
        End If
    End Sub


End Class
