Imports System.ComponentModel

' IMPORTANT NOTE: if you use the LicWindowsFileLicenseProvider license scheme you
'                 must copy the CustomControlsDemo.AddressControl.lic file from the
'                 \BIN subdirectory into the Windows System directory, otherwise
'                 you won't be able to use the AddressControl control at design time.

' change this constant to enforce different types of licensing.
' can be 0 (no license) 1 (standard file license), 2 (custom file license)

' If you opt for custom file license, ensure that you copy the 
' CustomControlDemo.AddressControl.lic to the c:\Windows\System directory

#Const USELICENSE = 0

#If USELICENSE = 1 Then
    <LicenseProvider(GetType(LicFileLicenseProvider))> _
    Public Class AddressControl

#ElseIf USELICENSE = 2 Then
    <LicenseProvider(GetType(LicWindowsFileLicenseProvider))> _
    Public Class AddressControl
#Else
    ' no licensing
    Public Class AddressControl
#End If

    Inherits System.Windows.Forms.UserControl

#Region " Windows Form Designer generated code "

    ' The License object
    Private lic As License

    Public Sub New()
        MyBase.New()

#If USELICENSE > 0 Then
        ' Validate the License.
        lic = LicenseManager.Validate(GetType(AddressControl), Me)
#End If

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
    End Sub

    'UserControl overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            ' destroy the license
            If Not (lic Is Nothing) Then
                lic.Dispose()
                lic = Nothing
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents Label4 As System.Windows.Forms.Label
    Friend WithEvents Label5 As System.Windows.Forms.Label
    Friend WithEvents txtStreet As System.Windows.Forms.TextBox
    Friend WithEvents txtState As System.Windows.Forms.TextBox
    Friend WithEvents txtCountry As System.Windows.Forms.TextBox
    Friend WithEvents txtCity As System.Windows.Forms.TextBox
    Friend WithEvents txtZip As System.Windows.Forms.TextBox

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.Container

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.txtStreet = New System.Windows.Forms.TextBox()
        Me.Label4 = New System.Windows.Forms.Label()
        Me.Label5 = New System.Windows.Forms.Label()
        Me.txtState = New System.Windows.Forms.TextBox()
        Me.txtCountry = New System.Windows.Forms.TextBox()
        Me.Label1 = New System.Windows.Forms.Label()
        Me.Label2 = New System.Windows.Forms.Label()
        Me.Label3 = New System.Windows.Forms.Label()
        Me.txtCity = New System.Windows.Forms.TextBox()
        Me.txtZip = New System.Windows.Forms.TextBox()
        Me.SuspendLayout()
        '
        'txtStreet
        '
        Me.txtStreet.Anchor = ((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right)
        Me.txtStreet.Location = New System.Drawing.Point(16, 40)
        Me.txtStreet.Name = "txtStreet"
        Me.txtStreet.Size = New System.Drawing.Size(360, 24)
        Me.txtStreet.TabIndex = 1
        Me.txtStreet.Text = ""
        '
        'Label4
        '
        Me.Label4.Location = New System.Drawing.Point(144, 136)
        Me.Label4.Name = "Label4"
        Me.Label4.Size = New System.Drawing.Size(48, 16)
        Me.Label4.TabIndex = 0
        Me.Label4.Text = "&State"
        '
        'Label5
        '
        Me.Label5.Location = New System.Drawing.Point(216, 136)
        Me.Label5.Name = "Label5"
        Me.Label5.Size = New System.Drawing.Size(72, 16)
        Me.Label5.TabIndex = 0
        Me.Label5.Text = "C&ountry"
        '
        'txtState
        '
        Me.txtState.Location = New System.Drawing.Point(144, 160)
        Me.txtState.Name = "txtState"
        Me.txtState.Size = New System.Drawing.Size(56, 24)
        Me.txtState.TabIndex = 1
        Me.txtState.Text = ""
        '
        'txtCountry
        '
        Me.txtCountry.Anchor = ((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right)
        Me.txtCountry.Location = New System.Drawing.Point(216, 160)
        Me.txtCountry.Name = "txtCountry"
        Me.txtCountry.Size = New System.Drawing.Size(160, 24)
        Me.txtCountry.TabIndex = 1
        Me.txtCountry.Text = ""
        '
        'Label1
        '
        Me.Label1.Location = New System.Drawing.Point(16, 72)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(144, 16)
        Me.Label1.TabIndex = 0
        Me.Label1.Text = "&City"
        '
        'Label2
        '
        Me.Label2.Location = New System.Drawing.Point(16, 136)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(72, 16)
        Me.Label2.TabIndex = 0
        Me.Label2.Text = "&Zip"
        '
        'Label3
        '
        Me.Label3.Location = New System.Drawing.Point(16, 16)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(144, 16)
        Me.Label3.TabIndex = 0
        Me.Label3.Text = "&Street"
        '
        'txtCity
        '
        Me.txtCity.Anchor = ((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right)
        Me.txtCity.Location = New System.Drawing.Point(16, 96)
        Me.txtCity.Name = "txtCity"
        Me.txtCity.Size = New System.Drawing.Size(360, 24)
        Me.txtCity.TabIndex = 1
        Me.txtCity.Text = ""
        '
        'txtZip
        '
        Me.txtZip.Location = New System.Drawing.Point(16, 160)
        Me.txtZip.Name = "txtZip"
        Me.txtZip.Size = New System.Drawing.Size(112, 24)
        Me.txtZip.TabIndex = 1
        Me.txtZip.Text = ""
        '
        'AddressControl
        '
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.Label5, Me.txtCountry, Me.Label4, Me.txtState, Me.Label2, Me.txtZip, Me.Label1, Me.txtCity, Me.txtStreet, Me.Label3})
        Me.Font = New System.Drawing.Font("Microsoft Sans Serif", 11.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Name = "AddressControl"
        Me.Size = New System.Drawing.Size(392, 200)
        Me.ResumeLayout(False)

    End Sub

#End Region

    Dim WithEvents m_Address As New Address()

    <TypeConverter(GetType(AddressTypeConverter))> _
    Property Address() As Address
        Get
            Return m_Address
        End Get
        Set(ByVal Value As Address)
            m_Address = Value
            RefreshControls()
        End Set
    End Property

    ' Refresh controls when any property changes
    Private Sub Address_PropertyChanged(ByVal propertyName As String) Handles m_Address.PropertyChanged
        RefreshControls()
    End Sub

    ' Display Address properties in the control's fields.
    Private Sub RefreshControls()
        txtStreet.Text = m_Address.Street
        txtCity.Text = m_Address.City
        txtZip.Text = m_Address.Zip
        txtState.Text = m_Address.State
        txtCountry.Text = m_Address.Country
    End Sub

    '---------------------------------------------
    ' The TypeConverter for the Address property
    '---------------------------------------------

    Public Class AddressTypeConverter
        Inherits TypeConverter

        Public Overloads Overrides Function GetProperties(ByVal context As System.ComponentModel.ITypeDescriptorContext, ByVal value As Object, ByVal attributes() As System.Attribute) As System.ComponentModel.PropertyDescriptorCollection
            Return TypeDescriptor.GetProperties(GetType(Address))
        End Function

        Public Overloads Overrides Function GetPropertiesSupported(ByVal context As System.ComponentModel.ITypeDescriptorContext) As Boolean
            Return True
        End Function
    End Class

End Class

'---------------------------------------------
' The class that holds Address info
'---------------------------------------------

Public Class Address
    Event PropertyChanged(ByVal propertyName As String)

    ' private members 
    Dim m_Street As String
    Dim m_City As String
    Dim m_Zip As String
    Dim m_State As String
    Dim m_Country As String

    Property Street() As String
        Get
            Return m_Street
        End Get
        Set(ByVal Value As String)
            If m_Street <> Value Then
                m_Street = Value
                RaiseEvent PropertyChanged("Street")
            End If
        End Set
    End Property

    Property City() As String
        Get
            Return m_City
        End Get
        Set(ByVal Value As String)
            If m_City <> Value Then
                m_City = Value
                RaiseEvent PropertyChanged("City")
            End If
        End Set
    End Property

    Property Zip() As String
        Get
            Return m_Zip
        End Get
        Set(ByVal Value As String)
            If m_Zip <> Value Then
                m_Zip = Value
                RaiseEvent PropertyChanged("Zip")
            End If
        End Set
    End Property

    Property State() As String
        Get
            Return m_State
        End Get
        Set(ByVal Value As String)
            If m_State <> Value Then
                m_State = Value
                RaiseEvent PropertyChanged("State")
            End If
        End Set
    End Property

    Property Country() As String
        Get
            Return m_Country
        End Get
        Set(ByVal Value As String)
            If m_Country <> Value Then
                m_Country = Value
                RaiseEvent PropertyChanged("Country")
            End If
        End Set
    End Property

    ' override ToString 
    Overrides Function ToString() As String
        Return "(Address)"
    End Function

End Class

' custom license provider class

Class LicWindowsFileLicenseProvider
    Inherits LicenseProvider

    Public Overrides Function GetLicense(ByVal context As LicenseContext, ByVal typ As System.Type, ByVal instance As Object, ByVal allowExceptions As Boolean) As License
        ' This is the name of the control.
        Dim ctrlName As String = typ.FullName

        If context.UsageMode = LicenseUsageMode.Designtime Then
            ' We are at design mode: check that there is a .lic file in Windows system directory.
            ' Build the full path of the .lic file.
            Dim filename As String = Environment.SystemDirectory() & "\" & ctrlName & ".lic"

            Dim fs As System.IO.StreamReader

            ' open the .lic file
            Try
                ' Open the license file, exception if not found.
                fs = New System.IO.StreamReader(filename)

                ' Read its contents.
                Dim licText As String = fs.ReadToEnd
                ' Compare with the expected license text.
                If licText <> ctrlName & " is a licensed component." Then
                    ' Any exception type will do.
                    Throw New ArgumentException()
                End If
            Catch ex As Exception

                ' Any error throws a LicenseException object, if possible
                ' else it just returns Nothing.
                If allowExceptions Then
                    Throw New LicenseException(typ, instance, "Can't find design-time license for " & ctrlName)
                Else
                    Return Nothing
                End If
            Finally
                ' In all cases, close the StreamReader if open.
                If Not (fs Is Nothing) Then fs.Close()
            End Try

            ' If we get here, we can return a RuntimeLicense object.
            Return New DesignTimeLicense(Me, typ)
        Else
            ' We enforce no licensing at runtime, so we always return a RunTimeLicense.
            Return New RuntimeLicense(Me, typ)
        End If
    End Function

    ' Nested class for design-time license.

    Public Class DesignTimeLicense
        Inherits License

        Private owner As LicWindowsFileLicenseProvider
        Private typ As Type

        ' The constructor for this class.
        Sub New(ByVal owner As LicWindowsFileLicenseProvider, ByVal typ As Type)
            Me.owner = owner
            Me.typ = typ
        End Sub

        Overrides ReadOnly Property LicenseKey() As String
            Get
                ' Just return the type name in this demo.
                Return typ.FullName
            End Get
        End Property

        Overrides Sub Dispose()
            ' There is nothing to do here.
        End Sub
    End Class

    ' Nested class for run-time license.

    Public Class RuntimeLicense
        Inherits License

        Private owner As LicWindowsFileLicenseProvider
        Private typ As Type

        ' The constructor for this class.
        Sub New(ByVal owner As LicWindowsFileLicenseProvider, ByVal typ As Type)
            Me.owner = owner
            Me.typ = typ
        End Sub

        Overrides ReadOnly Property LicenseKey() As String
            Get
                ' Just return the type name in this demo.
                Return typ.FullName
            End Get
        End Property

        Overrides Sub Dispose()
            ' There is nothing to do here.
        End Sub
    End Class
End Class